DEFINE CATPCA_Bootstrap1 (nboot=!TOKENS(1) 
                         /nrun=!TOKENS(1)
                         /alpha=!TOKENS(1)
                         /elpoints=!TOKENS(1)
                         /file=!TOKENS(1)
                         /variables=!CHAREND('#')
                         /analysis=!CHAREND('#')
                         /missing=!CMDEND ).

************************* SOME SET COMMANDS ********************************************.

*** preserve user settings; restored at end of macro ***.
PRESERVE.

SET PRINTBACK OFF.
SET OLANG=english.
SET OVARS NAMES TVARS NAMES.

GET FILE = !file.

OMS /DESTINATION VIEWER=NO /TAG='suppressall'.
OMS/SELECT TABLES
    /IF COMMANDS=['FREQUENCIES'] SUBTYPES=['Frequencies'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp1.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
FREQUENCIES VARIABLES = !variables .
OMSEND.
DATASET CLOSE ALL.
GET FILE 'tmp1.sav'.
SELECT IF (var1 = 'Valid').
SAVE OUTFILE='tmp1.sav'.
DATASET CLOSE ALL.

MATRIX.
get data /file= !file /MISSING=accept /SYSMIS=99999 /VARIABLES = !variables.
compute nobs = NROW(data).
save nobs /outfile='nobs.sav' /var = nobs.
compute nvar = NCOL(data).
save nvar /outfile='nvar.sav' /var = nvar.
get catfreq /file=  'tmp1.sav'  /MISSING=accept /SYSMIS=99999.
compute totcat = NROW(catfreq) - nvar.
save totcat /outfile='orgtotcat.sav' /var = totcat.
END MATRIX.

GET FILE='nobs.sav'.
MATCH FILES /FILE=* /FILE='orgtotcat.sav'.
compute nb = !nboot + 1.
COMPUTE tmp1 = 6200.
COMPUTE tmp2 = TRUNC((4 * nobs * nb) /128) + 1.
COMPUTE tmp3 = TRUNC((5 * totcat * nb) /128) + 1.
COMPUTE tmp = MAX(tmp1,tmp2,tmp3).
write out='tmp.sav'  
 /"define !ws() " tmp " !enddefine.".
exe. 
include file='tmp.sav' . 
write out='tmp.sav'  
 /"define !miter() " nb " !enddefine.".
exe. 
include file='tmp.sav' . 
SET WORKSPACE !ws.
SET MITERATE = !miter.  

compute nbtot = !nboot * !nrun.
compute tmp1 = nobs * nbtot.
compute tmp2 = nobs * !elpoints.
compute tmp3 = totcat * nbtot.
compute maxloop = MAX(tmp1,tmp2,tmp3).
write out='tmp.sav'  
 /"define !maxloop() " maxloop " !enddefine.".
exe. 
include file='tmp.sav' . 
SET MXLOOP=!maxloop. 

**************************************************************************************.

DATASET CLOSE ALL.
GET FILE=!file.
WEIGHT OFF.
compute col1 = 1.
VALUE LABELS !variables.
SAVE OUTFILE='tempdata.sav' /COMPRESSED.
DATASET CLOSE ALL.

MATRIX.
compute tmp = 0.
save tmp /outfile='cntzerovar.sav'.
END MATRIX.

!DO !run = 1 !TO !nrun

get file 'cntzerovar.sav'.
compute col1 = !nboot - col1.
FORMAT col1 (F5.0).
write out='tmp.sav'  
 /"define !stop() " col1 " !enddefine.".
exe. 
include file='tmp.sav' . 
INCLUDE 'CATPCA_Bootstrap2.sps'.
CATPCA_Bootstrap2
   nboot=!nboot
   run = !run
   stop = !stop
   alpha = !alpha
   elpoints = !elpoints
   file = !file
   variables = !variables #
   analysis = !analysis #
   missing = !missing .

get file 'cntzerovar.sav'.
compute col1 = !nboot - col1.
FORMAT col1 (F5.0).
write out='tmp.sav'  
 /"define !stop() " col1 " !enddefine.".
exe. 
include file='tmp.sav' . 
INCLUDE 'CATPCA_Bootstrap3.sps'.
CATPCA_Bootstrap3
   nboot=!nboot
   run = !run
   stop = !stop.

!DOEND

DATASET CLOSE ALL.
ERASE FILE 'tempdata.sav'.
ERASE FILE 'totcat.sav'.
ERASE FILE 'cntzerovartmp.sav'.

get file 'lastrun.sav'.
FORMAT lastrun (F5.0).
write out='tmp.sav'  
 /"define !lastrun() " lastrun " !enddefine.".
exe. 
include file='tmp.sav' . 

INCLUDE 'CATPCA_Bootstrap4.sps'.
CATPCA_Bootstrap4
   nboot=!nboot
   nrun = !nrun
   stop=!stop
   lastrun = !lastrun
   alpha = !alpha
   elpoints = !elpoints
   variables = !variables.

DATASET CLOSE ALL.
GET FILE=!file.
ERASE FILE 'cntzerovar.sav'.
ERASE FILE 'lastrun.sav'.

RESTORE.
!ENDDEFINE.
