DEFINE CATPCA_Bootstrap2 (nboot=!TOKENS(1) 
                         /run=!TOKENS(1)
                         /stop=!TOKENS(1)
                         /alpha=!TOKENS(1)
                         /elpoints=!TOKENS(1)
                         /file=!TOKENS(1)
                         /variables=!CHAREND('#')
                         /analysis=!CHAREND('#')
                         /missing=!CMDEND ).

!IF (!stop !NE 0) !THEN

********************** GET NUMBER OF OBJECTS IN ANALYSIS AND CASEID ****************************.
DATASET CLOSE ALL.
GET FILE='tempdata.sav'.

!IF (!run !GT 1) !THEN
OMS /DESTINATION VIEWER=NO /TAG='suppressall'.
!IFEND

OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Case Processing Summary'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Model Summary'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp1.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Component Loadings'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp2.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Object Scores'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp3.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
OMS/SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Quantifications'] 
    /DESTINATION FORMAT=SAV OUTFILE='tmp4.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
CATPCA
 /VARIABLES !variables
 !analysis
 !missing
  /PRINT obj load quant(all)
  /PLOT=load obj.
OMSEND.

MATRIX.
get caseproc /file= 'tmp.sav' /VAR var2.
compute nobsnm = caseproc(5).
save nobsnm /outfile='nobsnm.sav'.
get obj /file= 'tmp3.sav' /VAR var1 @1 /MISSING=accept /SYSMIS=99999.
get nobs /file= 'nobs.sav'.
compute cidnm = MAKE(nobsnm,1,0).
compute j = 0.
LOOP i = 1 TO nobs.
.   DO IF (obj(i,2) ne 99999).
.      compute j = j + 1.
.      compute cidnm(j) = obj(i,1).
.   END IF.
END LOOP.
save cidnm /outfile='cidnm.sav'.
END MATRIX.

************** Create variable names file and number of variables******************************.

MATRIX.
get vn /file= 'tmp2.sav' /var = var1.
compute nvar = NROW(vn) .
compute vname = MAKE(nvar,1,0).
LOOP j = 1 TO nvar.
compute vname(j,1)= vn(j).
END LOOP.
save nvar /outfile='nvar.sav'.
save vname /outfile='varnames.sav' /VAR=varname /STRINGS=varname.
END MATRIX.

************************* BALANCED BOOTSTRAP VECTOR ***********************************.

MATRIX.
get cidnm /file= 'cidnm.sav'.
get nobs /file= 'nobs.sav'.
get nobsnm /file= 'nobsnm.sav'.
compute nbs = !nboot.
compute tmp=MAKE((nbs*nobsnm),1,0).
compute n = 0.
loop  b=1 to nbs.
.   loop j =1 to nobsnm.
.      compute i = cidnm(j).
.		compute n = n + 1.
.		compute tmp(n,1) = i.
.   end loop.
end loop.
compute nobsvec=MAKE((nbs*nobsnm),1,nobs).
save tmp /outfile='bbootsvect.sav' /var=obsid.
save nobsvec /outfile='tmp.sav' /var=nobs.
END MATRIX.

DATASET CLOSE ALL.
get file 'bbootsvect.sav'.
SAVE OUTFILE='tmp1.sav' /COMPRESSED.
MATCH FILES /FILE=* /FILE='tmp.sav'.

SET SEED !run.

compute permvar = UNIFORM(!nboot*nobs).
SORT CASES BY permvar.
SAVE OUTFILE='tmp.sav' /drop permvar nobs.
DATASET CLOSE ALL.
GET FILE='tmp.sav'.
MATCH FILES /FILE=* /FILE='bbootsvect.sav'.
SAVE OUTFILE='bbootsvect.sav'.

************************* BOOTSTRAP CATPCA ********************************************.

OMS /DESTINATION VIEWER=NO /TAG='suppressall'.

OMS/SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Model Summary'] 
    /DESTINATION FORMAT=SAV OUTFILE='eigvalboot.sav'
    /COLUMNS SEQUENCE=[R2 C1] 
    /TAG='EV'.
OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Component Loadings'] 
    /DESTINATION FORMAT=SAV OUTFILE='loadboot.sav'
    /COLUMNS SEQUENCE=[R2 C1] 
    /TAG='LOAD'.
OMS /SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Object Scores'] 
    /DESTINATION FORMAT=SAV OUTFILE='objboot.sav'
    /COLUMNS SEQUENCE=[R2 C1] 
    /TAG='OBJ'.
OMS/SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Quantifications'] 
    /DESTINATION FORMAT=SAV OUTFILE='quantboot.sav'
    /COLUMNS SEQUENCE=[R2 C1] 
    /TAG='Quant'.

!DO !b = 0 !TO !nboot
*** !b = 0 is original sample ***.

MATRIX.
get tmp /file= 'bbootsvect.sav'.
get cidnm /file= 'cidnm.sav'.
get nobs /file= 'nobs.sav'.
get nobsnm /file= 'nobsnm.sav'.
!IF (!b !GT 0) !THEN
	compute bbtsmpl=MAKE(nobsnm,1,0).
.	compute smplwgt=MAKE(nobs,1,0).
.	compute n = nobsnm * (!b - 1).
.	LOOP i = 1 TO nobsnm.
.		compute n = n + 1.
.		compute bbtsmpl(i) = tmp(n).
.	END LOOP.
.	LOOP i = 1 TO nobsnm.
.		compute j = bbtsmpl(i) .
.		compute smplwgt(j) = smplwgt(j) + 1.
.	END LOOP.
.       compute nw = (smplwgt = 0).
.       compute nw = CSUM(nw).
.       DO IF ((nobs-nw) < 3).
.          compute a = 0.
.          compute b = 0.
.          LOOP i = 1 TO nobs.
.             DO IF (smplwgt(i) > 0).
.                compute a = i.
.             ELSE.
.                compute b = i.
.             END IF.
.             END LOOP IF ((a > 0) and (b > 0)).
.          compute smplwgt(a) = smplwgt(a) - 1.
.          compute smplwgt(b) = 1. 
.       END IF.
!ELSE
	compute smplwgt=MAKE(nobs,1,0).
.	LOOP i = 1 TO nobsnm.
.		compute smplwgt(cidnm(i)) = 2.
.	END LOOP.
!IFEND
save smplwgt /outfile='sampleweights.sav'.
END MATRIX.
DATASET CLOSE ALL.
GET FILE='tempdata.sav' /DROP COL1.
MATCH FILES /FILE=* /FILE='sampleweights.sav'.  
SAVE OUTFILE='tempdata.sav'/COMPRESSED.

OMS/SELECT TABLES
    /IF COMMANDS=['CATPCA'] SUBTYPES=['Descriptive Statistics'] 
    /DESTINATION FORMAT=SAV OUTFILE='descrip.sav'
    /COLUMNS SEQUENCE=[R2 C1] 
    /TAG='Descrip'.

WEIGHT BY COL1.
CATPCA
 /VARIABLES !variables
 !analysis
 !missing
  /DIMENSION=2
  /NORMALIZATION=VPRINCIPAL
  /MAXITER=500
  /CRITITER=.0000001
  /PRINT load obj quant(all) descrip(all)
  /PLOT=none.
WEIGHT OFF.

OMSEND TAG =['Descrip'].
DATASET CLOSE ALL.
GET FILE='descrip.sav'.
select if  (var1 = "Valid" AND var2 ~= "Total").
compute catnr = NUMBER(var2,F8.0).
SAVE OUTFILE='descrip.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IF (!b !EQ 0) !THEN
MATRIX.
get tmp /file= 'descrip.sav' /MISSING=accept /SYSMIS=99999.
compute ncat = NROW(tmp).
save ncat /outfile='totcattmp.sav'.
compute maxcat = CMAX(tmp(:,7)).
save maxcat /outfile='maxcat.sav' /var = maxcat.
compute cntzerov = 0.
save cntzerov /outfile='cntzerovar.sav'.
save cntzerov /outfile='cntzerovartmp.sav'.
END MATRIX.
!ELSE
MATRIX.
get descrip /file= 'descrip.sav' /MISSING=accept /SYSMIS=99999.
get nobsnm /file= 'nobsnm.sav'.
compute zerovar = CSUM((descrip(:,6)=nobsnm)).
get tmp /file= 'totcat.sav'.
DO IF (zerovar = 0).
.   compute nr = NROW(tmp).
.   compute totcat = MAKE((nr+1),1,0).
.   compute totcat(1:nr) = tmp.
.   compute ncat = NROW(descrip).
.   compute totcat(nr+1) = ncat.
ELSE.
.   get cntzerov /file= 'cntzerovar.sav'.
.   compute cntzerov = cntzerov + 1.
.   save cntzerov /outfile='cntzerovartmp.sav'.
.   compute totcat = tmp.
END IF.
save totcat /outfile='totcattmp.sav'.
END MATRIX.
!IFEND
DATASET CLOSE ALL.
GET FILE='totcattmp.sav'.
SAVE OUTFILE='totcat.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IF (!b !GT 0) !THEN
GET FILE='cntzerovartmp.sav'.
SAVE OUTFILE='cntzerovar.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IFEND

!DOEND
OMSEND.

GET FILE='cntzerovar.sav'.
compute col1 = !run - 1.
rename var (col1 = lastrun).
SAVE OUTFILE='lastrun.sav' /COMPRESSED.
DATASET CLOSE ALL.

ERASE FILE 'descrip.sav'.
ERASE FILE 'sampleweights.sav'.
ERASE FILE 'bbootsvect.sav'.
ERASE FILE 'cidnm.sav'.
ERASE FILE 'tmp1.sav'.
ERASE FILE 'tmp2.sav'.
ERASE FILE 'tmp3.sav'.
ERASE FILE 'tmp4.sav'.
ERASE FILE 'totcattmp.sav'.

!IFEND
!ENDDEFINE.
