DEFINE CATPCA_Bootstrap3 (nboot=!TOKENS(1) 
                                             /run=!TOKENS(1)
                                             /stop=!CMDEND ).


!IF (!stop !NE 0) !THEN

******************** EDIT OMS FILES **********************************************.

GET file 'eigvalboot.sav'.
select if (var1 ~= 'Total').
SAVE OUTFILE='eigvalboot.sav' /KEEP totaleigenvalue /COMPRESSED.
DATASET CLOSE ALL.
MATRIX.
get ev /file= 'eigvalboot.sav' /VAR = TotalEigenvalue.
compute nr = NROW(ev).
compute nsamples = (nr/2) - 1.
save nsamples /outfile='nsamples.sav' /var = ns.
compute eigval=MAKE((nsamples+1),2,0).
compute a = 0.
LOOP i = 1 TO nsamples + 1.
.   compute a = a + 1.
.   compute eigval(i,1) = ev(a).
.   compute a = a + 1.
.   compute eigval(i,2) = ev(a).
END LOOP.
compute bootev = eigval(2:(nsamples+1),:).
!IF (!run !EQ 1) !THEN
compute orgev = MAKE(1,3,1).
compute orgev(1,1:2) = eigval(1,:).
save orgev /outfile='eigvalorg.sav' /VAR= Dimension_1 Dimension_2 pointid.
!IFEND
save bootev /outfile=!QUOTE(!CONCAT ('eigvalboot',!run,'.sav')) /VAR= Dimension_1 Dimension_2.
END MATRIX.

DATASET CLOSE ALL.
GET FILE='loadboot.sav'.
SAVE OUTFILE='loadboot.sav' /KEEP @1 @2 /COMPRESSED.
DATASET CLOSE ALL.
MATRIX.
get load /file= 'loadboot.sav'.
get nvar /file= 'nvar.sav'.
get nsamples /file= 'nsamples.sav'.
compute bootload = MAKE((nvar*nsamples),3,0).
compute nr = NROW(load).
compute bootload(:,1:2) = load((nvar+1):nr,:).
!IF (!run !EQ 1) !THEN
compute orgload = MAKE(nvar,3,1).
compute orgload(:,1:2) = load(1:nvar,:).
save orgload /outfile='loadorg.sav' /VAR= Dimension_1 Dimension_2 pointid.
!IFEND
save bootload /outfile=!QUOTE(!CONCAT ('loadboot',!run,'.sav')) /VAR= Dimension_1 Dimension_2.
END MATRIX.

DATASET CLOSE ALL.
GET FILE='objboot.sav'.
SAVE OUTFILE='objboot.sav' /KEEP @1 @2 var1 objectweight /COMPRESSED.
DATASET CLOSE ALL.
MATRIX.
get bootobj /file= 'objboot.sav' /MISSING ACCEPT /SYSMIS 1.
get nobsnm /file= 'nobsnm.sav'.
get nobs /file= 'nobs.sav'.
get nsamples /file= 'nsamples.sav'.
!IF (!run !EQ 1) !THEN
compute orgobj = MAKE(nobsnm,4,1).
compute orgobj(:,1:3) = bootobj(1:nobsnm,1:3).
save orgobj /outfile='objorg.sav' /VAR=Dimension_1 Dimension_2 caseid pointid.
!IFEND
compute nr = NROW(bootobj).
compute btobjtmp = bootobj((nobsnm+1):nr,:).
compute bootobj = MAKE(nobsnm*nsamples,3,0).
compute nrowi = nr - nobsnm.
compute k = 0.
compute i = 0.
LOOP b = 1 TO nsamples.
.   LOOP j = 1 TO nobs.
.          compute i = i + 1.
.          DO IF (btobjtmp(i,3) = j).
.               LOOP m = 1 TO btobjtmp(i,4).
.                  compute k = k + 1.
.                  compute bootobj(k,1:2)= btobjtmp(i,1:2).
.                  compute bootobj(k,3)= btobjtmp(i,3).
.               END LOOP.
.          ELSE.
.              compute i = i - 1.
.          END IF.
.   END LOOP IF (i = nrowi).
END LOOP.
save bootobj /outfile=!QUOTE(!CONCAT ('objboot',!run,'.sav')) /VAR= Dimension_1 Dimension_2 caseid.
END MATRIX.

DATASET CLOSE ALL.
GET FILE='quantboot.sav'.
select if (var1 ~= "Missing").
AUTORECODE VARIABLES=Label_  /INTO varnr.
COMPUTE catnr=NUMBER(var1,F8.0).
SAVE OUTFILE='quantboot.sav' /KEEP label_ varnr catnr quantification /COMPRESSED.
DATASET CLOSE ALL.
MATRIX.
get tmp /file= 'quantboot.sav' /VAR quantification.
get ncat /file= 'totcat.sav'.
get nsamples /file= 'nsamples.sav'.
compute nr = NROW(tmp).
compute bootid = MAKE(nr,1,0).
compute i = 0.
LOOP b = 0 TO nsamples.
.    LOOP k = 1 TO ncat(b+1).
.       compute i = i + 1.
.       compute bootid(i) = b.
.   END LOOP.
END LOOP.
save bootid /outfile='bootid.sav'.
END MATRIX.
DATASET CLOSE ALL.
GET FILE='quantboot.sav'.
MATCH FILES /file=*/file='bootid.sav'.
SAVE OUTFILE='quantboot.sav' /COMPRESSED.
DATASET CLOSE ALL.
MATRIX.
get tmp /file= 'quantboot.sav'.
get orgtcat /file= 'orgtotcat.sav'.
compute orgquant = tmp(1:orgtcat,:).
save orgquant /outfile='quantorg.sav' /var label_ varnr catnr quantification bootid /STRINGS label_.
compute nr = NROW(tmp).
compute btquant = tmp((orgtcat+1):nr,:).
compute btquant(:,5) = btquant(:,5) + (!nboot*(!run-1)). 
save btquant /outfile=!QUOTE(!CONCAT ('quantboot',!run,'.sav')) /var label_ varnr catnr quantification bootid /STRINGS label_.
END MATRIX.

DATASET CLOSE ALL.
GET FILE='nsamples.sav'.
SAVE OUTFILE=!QUOTE(!CONCAT ('nsamples',!run,'.sav')) /COMPRESSED.

ERASE FILE 'bootid.sav'.

!IFEND

!ENDDEFINE.