DEFINE CATPCA_Bootstrap4 (nboot=!TOKENS(1) 
                         /nrun=!TOKENS(1)
                          /stop=!TOKENS(1)
                          /lastrun=!TOKENS(1)
                         /alpha=!TOKENS(1)
                         /elpoints=!TOKENS(1)
                         /variables=!CMDEND ).

!IF (!stop !ne 0) !THEN

****************************** MERGE FILES *****************************.

DATASET CLOSE ALL.
GET FILE='eigvalboot1.sav'.
!DO !i = 2 !TO !nrun
ADD FILES /FILE=* /FILE=!QUOTE(!CONCAT ('eigvalboot',!i,'.sav')) .
!DOEND
SAVE OUTFILE='eigvalboot.sav' /COMPRESSED.
DATASET CLOSE ALL.
!DO !i = 1 !TO !nrun
ERASE FILE !QUOTE(!CONCAT ('eigvalboot',!i,'.sav')) .
!DOEND

DATASET CLOSE ALL.
GET FILE='loadboot1.sav'.
!DO !i = 2 !TO !nrun
ADD FILES /FILE=* /FILE=!QUOTE(!CONCAT ('loadboot',!i,'.sav')) .
!DOEND
SAVE OUTFILE='loadboot.sav' /COMPRESSED.
DATASET CLOSE ALL.
!DO !i = 1 !TO !nrun
ERASE FILE !QUOTE(!CONCAT ('loadboot',!i,'.sav')) .
!DOEND

DATASET CLOSE ALL.
GET FILE='objboot1.sav'.
!DO !i = 2 !TO !nrun
ADD FILES /FILE=* /FILE=!QUOTE(!CONCAT ('objboot',!i,'.sav')) .
!DOEND
SAVE OUTFILE='objboot.sav' /COMPRESSED.
DATASET CLOSE ALL.
!DO !i = 1 !TO !nrun
ERASE FILE !QUOTE(!CONCAT ('objboot',!i,'.sav')) .
!DOEND

DATASET CLOSE ALL.
GET FILE='quantboot1.sav'.
!DO !i = 2 !TO !nrun
ADD FILES /FILE=* /FILE=!QUOTE(!CONCAT ('quantboot',!i,'.sav')) .
!DOEND
SAVE OUTFILE='quantboot.sav' /COMPRESSED.
DATASET CLOSE ALL.
!DO !i = 1 !TO !nrun
ERASE FILE !QUOTE(!CONCAT ('quantboot',!i,'.sav')) .
!DOEND

GET FILE='nsamples1.sav'.
!DO !i = 2 !TO !nrun
ADD FILES /FILE=* /FILE=!QUOTE(!CONCAT ('nsamples',!i,'.sav')) .
!DOEND
SAVE OUTFILE='tmp.sav' /COMPRESSED.
DATASET CLOSE ALL.
!DO !i = 1 !TO !nrun
ERASE FILE !QUOTE(!CONCAT ('nsamples',!i,'.sav')) .
!DOEND

MATRIX.
get tmp /file='tmp.sav'.
compute nboot = CSUM(tmp).
save nboot /outfile='nsamples.sav' /VAR ns.
END MATRIX.

********************************* ROTATION ****************************************.
GET FILE='nobsnm.sav'.
compute ns = !nboot * !nrun.
COMPUTE tmp1 = 6200.
COMPUTE tmp2 = TRUNC((3 * col1 * ns) /128) + 1.
COMPUTE tmp = MAX(tmp1,tmp2).
write out='tmp.sav'  
 /"define !ws() " tmp " !enddefine.".
exe. 
include file='tmp.sav' . 
SET WORKSPACE !ws.
DATASET CLOSE ALL.

MATRIX.
get orgload /file= 'loadorg.sav'.
get bootload /file= 'loadboot.sav'.
get nvar /file= 'nvar.sav'.
get nsamples /file= 'nsamples.sav'.
compute a = 1.
compute b = nvar.
LOOP s = 1 TO nsamples.
.   compute tmp = bootload(a:b,1:2).
.   compute ob=TRANSPOS(orgload(:,1:2))*tmp.
.   CALL SVD(ob,p,phi,q).
.   compute rot = q*TRANSPOS(p).
.   compute tmp = tmp * rot.
.   compute bootload(a:b,1:2) = tmp.
.   get bootobj /file= 'objboot.sav'.
.   get nobsnm /file= 'nobs.sav'.
.   compute c = 1.
.   compute d = nobsnm.
.   compute tmp = bootobj(c:d,1:2) * rot.
.   comppute bootobj(c:d,1:2) = tmp.
.   compute c = c + nobsnm.
.   compute d = d + nobsnm.
.   compute a = a + nvar.
.   compute b = b + nvar.
END LOOP.
save bootload /outfile='loadboot.sav' /VAR=dim1 dim2 varid.
save bootobj /outfile='objboot.sav' /VAR=dim1 dim2 objid.
END MATRIX.

************************* CONFIDENCE ELLIPSES ********************************************.

!DO !typeplot = 1 !TO 3

DATASET CLOSE ALL.
!IF (!typeplot !EQ 2) !THEN
get file 'nvar.sav'.
write out='tmp.sav'  
 /"define !npoints() " col1 " !enddefine.".
exe.
include file='tmp.sav' . 
!IFEND
!IF (!typeplot !EQ 3) !THEN
get file 'nobsnm.sav'.
write out='tmp.sav'  
 /"define !npoints() " col1 " !enddefine.".
exe.
include file='tmp.sav' . 
DATASET CLOSE ALL.
get file 'objboot.sav'.
OMS /DESTINATION VIEWER=NO /TAG='suppressall'.
OMS/SELECT TABLES
    /IF COMMANDS=['FREQUENCIES'] SUBTYPES=['Frequencies'] 
    /DESTINATION FORMAT=SAV OUTFILE='freqobj.sav'
    /COLUMNS SEQUENCE=[R2 C1] .
FREQUENCIES VARIABLES=objid.
OMSEND.

!IFEND

** Compute alpha*100% Confidence Ellipse **.
MATRIX.
*** !typeplot = 1 eigval, 2 load, 3 obj ***.
*** npoint = 1 for eigval, npoint = nvar for load, npoint = nobsnm for obj ***.
get nboot /file= 'nsamples.sav'.
!IF (!typeplot !EQ 1) !THEN
compute np = 1.
!ELSE
compute np = !npoints.
!IFEND
compute typeplot = !typeplot.
compute aprop = !alpha/100.
compute nelp = !elpoints.
compute elarea = MAKE(np,1,0).
compute distorig = MAKE(np,1,0).
!IF (!typeplot !EQ 1) !THEN
     get btvalues /file= 'eigvalboot.sav'.
.    compute elp=MAKE(nelp+1,3,2).
.    compute zero = MAKE(1,3,0).
.    compute elp(nelp+1,:) = zero.
!IFEND
!IF (!typeplot !EQ 2) !THEN
     get btvalues /file= 'loadboot.sav'.
.    get vname /file= 'varnames.sav'.
.    compute elp=MAKE((nelp*np+1),6,2).
.    compute zero = MAKE(1,6,0).
.    compute elp(nelp*np+1,:) = zero.
!IFEND
!IF (!typeplot !EQ 3) !THEN
compute totboot = !nboot * !nrun.
DO IF (nboot LT totboot).
.   print /title '!!! WARNING !!! SOME BOOTSTRAP SAMPLES WERE EXLUDED BECAUSE OF VARIABLES'.
.   print /title '                WITH ZERO VARIANCE (resulting in unbalanced bootstrap).' /space 0.
.   print nboot  /format "f20.0"  /title= '                NUMBER OF SAMPLES USED:' /space 0.
.   print /title '                (Remedy: Increase number of bootstraps.)' /space 0.
END IF.
.   get freqobj /file= 'freqobj.sav' /VAR = frequency.
.   compute maxnboot = CMAX(freqobj(1:np,:)).
.   get btvalues /file= 'objboot.sav'.
.   get nobs /file= 'nobs.sav'.
.   compute btcldall = MAKE(maxnboot,2*nobs,0).
.   compute rowcnt = MAKE(nobs,1,0).
.   compute nr = NROW(btvalues).
.   LOOP k = 1 TO nr.
.      compute rowcnt(btvalues(k,3)) = rowcnt(btvalues(k,3)) + 1.
.      compute i = rowcnt(btvalues(k,3)).
.      compute j = btvalues(k,3) * 2.
.      compute btcldall(i,(j-1):j) = btvalues(k,1:2).
.   END LOOP.
.   release freqobj.
.   release btvalues.
.   compute elp=MAKE((nelp*np),6,2).
!IFEND
compute cnt = 0.
LOOP p = 1 TO np.
compute freq1 = 0.
DO IF (typeplot = 3).
.   compute freq1 = (rowcnt(p)=1).
END IF.
DO IF (typeplot = 1).
.   compute bootcld = btvalues(:,1:2).
END IF.
DO IF (typeplot = 2).
.   get nboot /file= 'nsamples.sav'.
.   compute bootcld = MAKE(nboot,2,0).
.   get nvar /file= 'nvar.sav'.
.   compute k = p.
.   LOOP i = 1 TO nboot.
.         compute bootcld(i,1:2) = btvalues(k,1:2).
.         compute k = k + nvar.
.   END LOOP.
END IF.
DO IF (freq1 = 0).
!IF (!typeplot !EQ 3) !THEN
.   compute nboot = rowcnt(p).
*  when samples are excluded because of variables with zero variance, the number of bootstrap 
*  samples for an object can be different from the specified number of samples (then unbalanced).
.   compute bootcld = MAKE(nboot,2,0).
.   compute j = p * 2.
.   compute bootcld = btcldall(1:nboot,(j-1):j).
!IFEND
compute meanvec = CSUM(bootcld) / nboot.
compute u=MAKE(nboot,1,1).
compute bootcld = bootcld - u * meanvec.
CALL SVD(bootcld,pev,phi,qev).
compute pev = pev(1:nboot,1:2).
compute phi = phi(1:2,1:2).
compute dist = RSUM(pev&**2).
compute sortdist = dist.
compute sortdist(GRADE(dist)) = dist.
compute tmp = MAKE(2,1,1).
compute tmp(2) = TRUNC(aprop*nboot+0.5).
compute mi = CMAX(tmp).
compute tmp = MAKE(2,1,nboot).
compute tmp(2) = mi+1. 
compute ma = CMIN(tmp).
compute a = aprop*nboot + 0.5 - mi.
compute rad = (1-a)*SQRT(sortdist(mi)) + a*SQRT(sortdist(ma)).
compute pi=4*artan(1).
compute elarea(p)=pi*(rad**2)*phi(1,1)*phi(2,2).
compute i = MAKE(nelp,1,0).
LOOP j = 1 to nelp.
.   compute i(j) = (2*pi*(j-1))/nelp.
END LOOP.
compute z = MAKE(nelp,2,0).
compute z(1:nelp,1) = rad*cos(i).
compute z(1:nelp,2) = rad*sin(i).
compute z = z * phi * T(qev).
compute z(:,1) = z(:,1) + meanvec(1).
compute z(:,2) = z(:,2) + meanvec(2).
!IF (!typeplot !EQ 2) !THEN
get org /file= 'loadorg.sav'.
!IFEND
!IF (!typeplot !EQ 3) !THEN
get org /file= 'objorg.sav'.
!IFEND
!IF (!typeplot !NE 1) !THEN
compute distorig(p) = SQRT(org(p,1)**2 + org(p,2)**2).
!IFEND
LOOP i = 1 TO nelp.
.   compute cnt = cnt + 1.
.   compute elp(cnt,1:2)=z(i,1:2).
.   DO IF (typeplot = 2).
.      compute elp(cnt,3)= vname(p).
.   END IF.
.   DO IF (typeplot = 3).
.      compute elp(cnt,3)= p.
.   END IF.
.   DO IF (typeplot NE 1).
.   compute elp(cnt,4) = elarea(p).
.   compute elp(cnt,5) = distorig(p).
.   END IF.
END LOOP.
END IF.
DO IF (freq1 NE 0).
.   print /title '!!! WARNING !!! CASE OCCURING ONLY ONCE IN THE BOOTSTRAP SAMPLES'.
.   print p /format "f20.0" /title '                (so, no ellips can be created):' /space 0.
.   print /title '                (Remedy: Increase number of bootstraps.)' /space 0.
END IF.
END LOOP.
save elarea /outfile='elarea.sav' /var = ellipsarea.
!IF (!typeplot !NE 1) !THEN
save distorig /outfile='distorig.sav' /var = distorig.
!IFEND
!IF (!typeplot !EQ 1) !THEN
save elp /outfile='elp.sav' /var = Dimension_1 Dimension_2 pointid.
!IFEND
!IF (!typeplot !EQ 2) !THEN
save elp /outfile='elp.sav' /var = Dimension_1 Dimension_2 varname ellipsarea distorig pointid /STRINGS varname.
!IFEND
!IF (!typeplot !EQ 3) !THEN
save elp /outfile='elp.sav' /var = Dimension_1 Dimension_2 caseid ellipsarea distorig pointid.
!IFEND
END MATRIX.

!IF (!typeplot !EQ 1) !THEN
DATASET CLOSE ALL.
GET FILE='eigvalorg.sav'.
MATCH FILES /FILE=* /FILE='elarea.sav'.
ADD FILES /FILE=* /FILE='elp.sav'.
VALUE LABELS pointid 0 'origin' 1 'eigenvalue' 2 'ellips'.
SAVE OUTFILE='elpev.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IFEND
!IF (!typeplot !EQ 2) !THEN
DATASET CLOSE ALL.
GET FILE='loadorg.sav'.
MATCH FILES /FILE=* /FILE='elarea.sav'.
MATCH FILES /FILE=* /FILE='distorig.sav'.
MATCH FILES /FILE=* /FILE='varnames.sav'.
ADD FILES /FILE=* /FILE='elp.sav'.
IF (pointid = 0) varname = 'origin'.
SAVE OUTFILE='elpload.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IFEND

!IF (!typeplot !EQ 3) !THEN
DATASET CLOSE ALL.
GET FILE='objorg.sav'.
MATCH FILES /FILE=* /FILE='elarea.sav'.
MATCH FILES /FILE=* /FILE='distorig.sav'.
ADD FILES /FILE=* /FILE='elp.sav'.
VALUE LABELS pointid 1 'object scores' 2 'ellips'.
SAVE OUTFILE='elpobj.sav' /COMPRESSED.
DATASET CLOSE ALL.
!IFEND

DATASET CLOSE ALL.
ERASE FILE 'tmp.sav'.
ERASE FILE 'elp.sav'.
ERASE FILE 'elarea.sav'.
!IF (!typeplot !NE 1) !THEN
ERASE FILE 'distorig.sav'.
!IFEND

!DOEND

ERASE FILE 'nobs.sav'.
ERASE FILE 'eigvalboot.sav'.
ERASE FILE 'eigvalorg.sav'.
ERASE FILE 'loadboot.sav'.
ERASE FILE 'loadorg.sav'.
ERASE FILE 'objboot.sav'.
ERASE FILE 'objorg.sav'.

DATASET CLOSE ALL.
get file= 'elpev.sav'.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.

DATASET CLOSE ALL.
get file= 'elpload.sav'.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by varname /TEMPLATE 'plotellipses15.sgt'.

DATASET CLOSE ALL.
get file= 'elpobj.sav'.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.


****************** CONFIDENCE REGIONS QUANTIFICATIONS *********************.

DATASET CLOSE ALL.
GET FILE 'quantorg.sav'.
SORT CASES BY varnr .
SAVE OUTFILE='quantorg.sav' /COMPRESSED.

SPLIT FILE LAYERED BY varnr .
OMS /DESTINATION VIEWER=NO /TAG='suppressall'.
OMS/SELECT TABLES
    /IF COMMANDS=['DESCRIPTIVES'] SUBTYPES=['Descriptive Statistics'] 
    /DESTINATION FORMAT=SAV OUTFILE='orgmaxcat.sav'
    /COLUMNS SEQUENCE=[C1 R2] .
DESCRIPTIVES  VARIABLES=catnr /STATISTICS=MAX .
OMSEND.
DATASET CLOSE ALL.
GET FILE 'orgmaxcat.sav'.
SAVE OUTFILE='orgmaxcat.sav' /KEEP maximum_catnr /COMPRESSED.

DATASET CLOSE ALL.
GET FILE 'quantorg.sav'.
OMS /DESTINATION VIEWER=NO /TAG='suppressall'.
OMS/SELECT TABLES
    /IF COMMANDS=['FREQUENCIES'] SUBTYPES=['Frequencies'] 
    /DESTINATION FORMAT=SAV OUTFILE='ncat.sav'
    /COLUMNS SEQUENCE=[C1 R2] .
FREQUENCIES VARIABLES=varnr.
OMSEND.
DATASET CLOSE ALL.
GET FILE 'ncat.sav'.
SELECT IF (var2 ~= 'Total').
SAVE OUTFILE='ncat.sav' /KEEP frequency /COMPRESSED.
DATASET CLOSE ALL.

GET FILE='orgtotcat.sav'.
compute ns = !nboot * !nrun.
COMPUTE tmp1 = 6200.
COMPUTE tmp2 = TRUNC((4 * totcat * ns) /128) + 1.
COMPUTE tmp = MAX(tmp1,tmp2).
write out='tmp.sav'  
 /"define !ws() " tmp " !enddefine.".
exe. 
include file='tmp.sav' . 
SET WORKSPACE !ws.
DATASET CLOSE ALL.

MATRIX.
get orgq /file= 'quantorg.sav' /VAR = varnr label_  catnr  quantification.
get q /file= 'quantboot.sav' /VAR = varnr label_  catnr  quantification.
get nvar /file= 'nvar.sav'.
get ncat /file= 'ncat.sav'.
get maxcat /file= 'orgmaxcat.sav'.
compute aprop = !alpha/100.
compute totcat = CSUM(ncat).
compute qconf = MAKE(totcat,5,0).
get ns /file= 'nsamples.sav'.
compute qboot = MAKE(totcat,(ns+3),99999).
compute qboot(:,1:3) = orgq(:,1:3).
compute cnt = 0.
LOOP var = 1 TO nvar.
LOOP cat = 1 TO maxcat(var).
compute ix =  (q(:,1) = var AND q(:,3) = cat).
compute bootfreq = CSUM(ix).
DO IF (bootfreq NE 0).
.   compute cnt = cnt + 1.
.   compute nr = NROW(q).
.   compute ix1 = MAKE(bootfreq,1,0).
.   DO IF (nr NE bootfreq).
.   compute ix0 = MAKE((nr-bootfreq),1,0).
.   END IF.
.   compute cnt1 = 0.
.   compute cnt0 = 0.
.   LOOP i = 1 TO nr.
.      DO IF (ix(i) = 1).
.         compute cnt1 = cnt1 + 1.
.         compute ix1(cnt1) = i.
.      ELSE.
.         compute cnt0 = cnt0 + 1.
.         compute ix0(cnt0) = i.
.      END IF.
.   END LOOP.
.   compute qbooti = q(ix1,4).
.   compute qboot(cnt,4:(bootfreq+3)) = T(qbooti).
.   DO IF (nr NE bootfreq).
.   compute q = q(ix0,:).
.   END IF.
.   compute rnkqboot = GRADE(qbooti).
.   compute ma=RND((aprop+(.5*(1-aprop)))*bootfreq).
.   compute mi=RND(.5*(1-aprop)*bootfreq). 
.   do if (mi = 0).
.      compute mi = mi + 1.
.   end if.
.   compute fndma = 0.
.   compute fndmi = 0.
.   loop i = 1 to bootfreq.
.        do if (rnkqboot(i) = ma AND fndma = 0). 
.           compute ixma = i .
.           compute fndma = 1.
.        end if . 
.        do if (rnkqboot(i) = mi AND fndmi = 0).
.           compute ixmi = i.
.           compute fndmi = 1. 
.        end if . 
.   end loop if ((fndma + fndmi) EQ 2). 
.   compute lowbnd = qbooti(ixmi,:).
.   compute upbnd = qbooti(ixma,:).
.   compute qconf(cnt,1) = lowbnd.
.   compute qconf(cnt,2) = orgq(cnt,4).
.   compute qconf(cnt,3) = upbnd.
.   compute qconf(cnt,4) = orgq(cnt,2).
.   compute qconf(cnt,5) = orgq(cnt,3).
END IF.
END LOOP.
END LOOP.
save qconf /outfile='quantconf.sav' /VAR lowerbound original upperbound varname catid /STRINGS  varname.
save qboot /outfile='quantboot.sav' /VAR varnumber varname catnumber /STRINGS  varname.
END MATRIX.

DATASET CLOSE ALL.
get file= 'quantconf.sav'.
!DO !var !IN (!variables)
USE ALL.
COMPUTE filter=(varname = !QUOTE(!var)).
FILTER BY filter.
VAR  LABEL catid !var.
GRAPH /LINE(MULTIPLE)=MEAN(lowerbound) MEAN(original) MEAN(upperbound) BY catid   /TEMPLATE='transplot15.sgt'.
!DOEND.

DATASET CLOSE ALL.
ERASE FILE 'tmp.sav'.
ERASE FILE 'freqobj.sav'.
ERASE FILE 'ncat.sav'.
ERASE FILE 'orgmaxcat.sav'.
ERASE FILE 'nsamples.sav'.
ERASE FILE 'quantorg.sav'.
ERASE FILE 'quantboot.sav'.

!ELSE

MATRIX.
.   print /title '!!! ERROR !!! VARIABLES WITH ZERO VARIANCE IN TOO MANY BOOTSTRAP SAMPLES.'.
.   print /title '              EXECUTION STOPPED.' /space 0.
.   print /title '              REMEDY: INCREASE NUMBER OF BOOTSTRAPS.' /space 0.
END MATRIX.

!IF (!lastrun !NE 0) !THEN
DATASET CLOSE ALL.
!DO !i = 1 !TO !lastrun
ERASE FILE !QUOTE(!CONCAT ('eigvalboot',!i,'.sav')) .
!DOEND
!DO !i = 1 !TO !lastrun
ERASE FILE !QUOTE(!CONCAT ('loadboot',!i,'.sav')) .
!DOEND
!DO !i = 1 !TO !lastrun
ERASE FILE !QUOTE(!CONCAT ('objboot',!i,'.sav')) .
!DOEND
!DO !i = 1 !TO !lastrun
ERASE FILE !QUOTE(!CONCAT ('quantboot',!i,'.sav')) .
!DOEND
!DO !i = 1 !TO !lastrun
ERASE FILE !QUOTE(!CONCAT ('nsamples',!i,'.sav')) .
!DOEND
ERASE FILE 'nsamples.sav'.
ERASE FILE 'eigvalorg.sav'.
ERASE FILE 'loadorg.sav'.
ERASE FILE 'objorg.sav'.
ERASE FILE 'quantorg.sav'.
!IFEND

ERASE FILE 'nobs.sav'.
ERASE FILE 'eigvalboot.sav'.
ERASE FILE 'loadboot.sav'.
ERASE FILE 'objboot.sav'.
ERASE FILE 'quantboot.sav'.
ERASE FILE 'tmp.sav'.

!IFEND

DATASET CLOSE ALL.
ERASE FILE 'nvar.sav'.
ERASE FILE 'nobsnm.sav'.
ERASE FILE 'orgtotcat.sav'.
ERASE FILE 'maxcat.sav'.
ERASE FILE 'varnames.sav'.

!ENDDEFINE.
