*** Replace c:\projects\catpcaboot by your directory path***.
CD 'c:\projects\catpcaboot'.

****************************************** EIGENVALUES ********************************************.
DATASET CLOSE ALL.
get file= 'elpev.sav'.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.


********************************************* LOADINGS **********************************************.
DATASET CLOSE ALL.
get file= 'elpload.sav'.

*** Plot all loadings and ellipses.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by varname /TEMPLATE 'plotellipses15.sgt'.

*** Plot loadings and ellipses for specific variables.
*** Replace 'v1' 'v2' 'v3' in ANY(varname, 'v1', 'v2', 'v3') with the names of the variables (in quotes) for which
*** ellipses should be produced.
USE ALL.
compute plotvars = ANY(varname, 'v1', 'v2', 'v3', 'origin').
FILTER BY plotvars.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by varname /TEMPLATE 'plotellipses15.sgt'.
USE ALL.
 
*** Plot only loadings and ellipses for loadings with distance to origin greater than a specified value.
*** Replace 0.75 with your value.
USE ALL.
COMPUTE filter = (distorig > 0.75 OR pointid = 0). 
FILTER BY filter.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.
USE ALL.

*** Plot only loadings and ellipses for loadings with ellips area greater than a specified  value.
*** Replace 0.2 with your value.
USE ALL. 
COMPUTE filter = (ellipsarea > 0.2 OR pointid = 0). 
FILTER BY filter.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.
USE ALL.


************************************* COMPONENT SCORES *****************************************.
DATASET CLOSE ALL.
get file= 'elpobj.sav'.

*** Plot all component score points and ellipses.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.

*** Plot component scores and ellipses for specific cases.
*** Replace 1, 2, 5, in ANY(caseid, 1, 2, 5) with the case numbers for which ellipses should be
*** produced.
USE ALL.
compute plotcases = ANY(caseid, 1, 2, 5).
FILTER BY plotcases.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by caseid /TEMPLATE 'plotellipses15.sgt'.
USE ALL.

*** Plot only component score points and ellipses for scores with distance to origin greater than a specified value.
*** Replace 0.75 with your value.
USE ALL.
COMPUTE filter = ( distorig > 0.75). 
FILTER BY filter.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.
USE ALL.

*** Plot only component score points and ellipses for scores with ellips area greater than a specified value.
*** Replace 5 with your value. 
USE ALL.
COMPUTE filter = (ellipsarea > 5). 
FILTER BY filter.
graph /scatterplot(bivar)= dimension_1 with dimension_2 by pointid /TEMPLATE 'plotellipses15.sgt'.
USE ALL.


***************************************** QUANTIFICATIONS *****************************************.
DATASET CLOSE ALL.
get file= 'quantconf.sav'.

*** Transformation plot with confidence region for 1 variable.
*** Replace 'v1' with your variable name (in quotes).
USE ALL.
DEFINE !var() 'v1' !ENDDEFINE.
COMPUTE filter=(varname = !var).
FILTER BY filter.
VAR  LABEL catid !var.
GRAPH /LINE(MULTIPLE)=MEAN(lowerbound) MEAN(original) MEAN(upperbound) BY catid  /TEMPLATE='transplot15.sgt'.
USE ALL.
