preserve.
set printback=on.

* SIMPLE AND COMPLEX RANDOM ASSIGNMENT IN EXPERIMENTAL DESIGNS
  Valentim R. Alferes, University of Coimbra (Portugal), 2009.
  
* StrataRand1.sps - Stratified Random Assignment (No restrictions).

set printback=off.
set ovars labels onumbers values tvars labels tnumbers values.
set errors=none.
data list list/Stratum(f8.0) nstrata(f8.0).

* Enter Stratum number and number of units per Stratum.
begin data
1 22
2 53
3 45
4 61
end data.

* Enter number of treaments.
compute ntreat = 4.

loop cases=1 to nstrata.
xsave outfile=outf1/keep=Stratum ntreat.
end loop.
get file=outf1.
compute x=$casenum.
rank variables=x(a) by Stratum/rank/print=no.
set seed random.
compute random=rv.uniform(0,ntreat).
compute Treatment=trunc(random)+1.
formats all(f8.0).
variable labels Rx"Unit".
oms/select tables/if commands=["summarize"]
 subtypes=["case processing summary"]/destination viewer=no.
oms/select tables/if commands=["crosstabs"]
 subtypes=["case processing summary"]/destination viewer=no.
sort cases by Stratum(a) rx(a).
summarize/tables=Stratum rx treatment/format=validlist nocasenum nototal
 /title='Stratified Random Assignment \n Sorted by Stratum/Unit'/cells=none.
sort cases by treatment(a) Stratum(a) rx(a).
summarize/tables=Stratum rx treatment/format=validlist nocasenum nototal
 /title='Stratified Random Assignment \n Sorted by Treatment'/cells=none.
crosstabs/tables=Stratum by Treatment/cells=count row.
restore.



